﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Editors;

namespace XamComboEditorEx
{
    public class XamComboEditorEx : XamComboEditor
    {
        public XamComboEditorEx() : base()
        {
            this.SelectionChanged += combo_SelectionChanged;
        }

        public string SelectedValuePath
        {
            get { return (string)GetValue(SelectedValuePathProperty); }
            set { SetValue(SelectedValuePathProperty, value); }
        }

        public static readonly DependencyProperty SelectedValuePathProperty =
            DependencyProperty.Register("SelectedValuePath", typeof(string), typeof(XamComboEditorEx),
            new PropertyMetadata(new PropertyChangedCallback(SelectedValuePath_Changed)));

        public object SelectedValue
        {
            get { return (object)GetValue(SelectedValueProperty); }
            set { SetValue(SelectedValueProperty, value); }
        }

        public static readonly DependencyProperty SelectedValueProperty =
            DependencyProperty.Register("SelectedValue", typeof(object), typeof(XamComboEditorEx), null);

        private static void SelectedValuePath_Changed(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            var combo = d as XamComboEditorEx;
            if (combo != null)
            {
                combo.ResetSelectedValue();
            }
        }

        static void combo_SelectionChanged(object sender, EventArgs e)
        {
            var combo = sender as XamComboEditorEx;
            if (combo != null)
                combo.ResetSelectedValue();
        }

        private void ResetSelectedValue()
        {
            if (this.SelectedItem != null)
                this.SelectedValue = this.SelectedItem.GetType().GetProperty(this.SelectedValuePath).GetValue(this.SelectedItem, null);
        }
    }
}
